#!/bin/sh
#
#         P F L I S T S
#
#      pf frontend for OS X
#
#        www.hanynet.com
#
#        by Hany El Imam
#
# pf startup script by hany@hanynet.com
#
#
#
# PFLists is free software. Please support free software!
# We accept small PayPal donations to << hany@hanynet.com >>
# We also accept and welcome BitCoin donations to address:
# << 16UvmZcqEEYT5gYrTaGrh82d12726fQi5x >> ...Thank you!
#
# PLEASE NOTE:
#
# this script has been installed by PFLists
# please chmod +x this script if you put/replace it manually!!
#
# this script must be executed at boot time by launchd
# it enables the PF firewall (full enabled, not "on demand")
# and loads rules from default osx configuration file /etc/pf.conf
# it enables also pf logging using tcpdump
# in order for logging to work you must add this line to /etc/syslog.conf:
# local2.*						/var/log/pffirewall.log
# this is done automatically by PFLists
#
# please note: this works on OSX 10.7 or later
# earlier MacOSX versions are not supported, they lack PF and use IPFW instead.

# start script

#
# We need to trap on TERM signals, according to Apple's launchd docs:
#
trap 'exit 1' 15

#
# Issue a log message so we know when we started (disabled by default)
#
# syslog -s -l 1 icefloor.sh: Starting PFLists PF firewall boot script...

#
# Use the "ipconfig waitall" command to wait for all the interfaces to come up:
#
ipconfig waitall

#
# System sysctl 
#
sysctl -w net.inet6.ip6.fw.verbose=0
sysctl -w net.inet.ip.fw.verbose=0
sysctl -w net.inet.ip.fw.verbose_limit=0

#
# interface forwarding
#
sysctl -w net.inet.ip.forwarding=0
		
#		
# enable PF and load rules from default PFLIsts configuration file
#
/sbin/pfctl -ef /etc/pflists.conf

#
# enable pf logs using tcpdump (osx seems to lack a better way to log pf -nov2012-)
#
ifconfig pflog0 create
/usr/sbin/tcpdump -lnettti pflog0 | /usr/bin/logger -t pf -p local2.info

#
# Sleep (disabled by default; enable it if you have problems starting logs or rules at system boot) 
#
# sleep 5

#
# log message (disabled by default)
#
# syslog -s -l 1 icefloor.sh: PFLists script ended.

# Exit with a clean status
exit 0