--
-- PFLists
--
-- pf firewall frontend for OS X
--
-- by Hany El Imam 
-- hanynet.com
-- 22.09.2013
--

-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					PROPERTIES
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

property binaryPath : missing value -- path to running application bundle
property macosxVersion : missing value -- os x version
property appdir : "/Library/Preferences/PFLists/" -- PFLists configuration working directory (ruleset database)
property startApp : missing value
property PFListsBuild : missing value
property PFListsVersion : missing value
property LocalIPaddress : missing value
property LocalMask : missing value
property LocalNetworkAddress : missing value
property firstClick : missing value
property selectedPr : missing value

-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					ON CLICKED
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

on clicked theObject
	if the name of theObject is equal to "close" then
		close window of theObject -- close current window
	else if the name of theObject is equal to "closepanel" then
		close panel window of theObject -- close current attached panel
	else if the name of theObject is equal to "closewelcome" then
		close panel window of theObject -- close current attached panel
		display panel window "help" attached to window "main"
	else if the name of theObject is equal to "closeit" then
		close panel window of theObject -- close current attached panel
	else if the name of theObject is equal to "addlist" then
		addList() -- show window add new list
	else if the name of theObject is equal to "dellist" then
		delList() -- delete selected list
	else if the name of theObject is equal to "addthelist" then
		addTheList() -- add currently defined list as new list 
	else if the name of theObject is equal to "update" then
		updateInterface()
		updateContent()
		updateServices() -- update interface
	else if the name of theObject is equal to "addcontent" then
		addContent() -- show window add content
	else if the name of theObject is equal to "delcontent" then
		delContent() -- delete selected content from selected list
	else if the name of theObject is equal to "addthecontent" then
		addTheContent() -- add selected content
	else if the name of theObject is equal to "lists" then
		--updateContent() -- update content table when changing list selection
		--updateServices()
	else if the name of theObject is equal to "addservice" then
		addService() -- show window add service
	else if the name of theObject is equal to "delservice" then
		delService() -- delete selected service from current list's services
	else if the name of theObject is equal to "addtheservice" then
		addTheService() -- add selected service to selected list
	else if the name of theObject is equal to "newcustomservice" then
		addNewCustomService()
	else if the name of theObject is equal to "addthenewcustomservice" then
		addTheNewCustomService()
	else if the name of theObject is equal to "removecustomservice" then
		delCustomService()
	else if the name of theObject is equal to "options" then
		show window "options"
	else if the name of theObject is equal to "paypaldonate" then
		do shell script "open http://www.hanynet.com/donate.html"
	else if the name of theObject is equal to "icefloor" then
		do shell script "open http://www.hanynet.com/icefloor"
	else if the name of theObject is equal to "restoreservicedb" then
		restoreDB()
	else if the name of theObject is equal to "guide" then
		do shell script "open \"" & binaryPath & "UserGuide.pdf\""
	else if the name of theObject is equal to "quit" then
		quit
	else if the name of theObject is equal to "importlist" then
		importList()
		checkOptions()
	else if the name of theObject is equal to "clear" then
		set the contents of text field "addcontent" of window "addcontent" to ""
	else if the name of theObject is equal to "showlogs" then
		showlogs()
	else if the name of theObject is equal to "exportlogs" then
		exportlogs()
	else if the name of theObject is equal to "debug" then
		show window "debug"
		updatedebug()
	else if the name of theObject is equal to "updatedebug" then
		updatedebug()
		----------------------------------
		-- SAVE OPTIONS: com.apple, emergingthreats, portknocking
	else if the name of theObject is equal to "comapple" then
		setComApple()
	else if the name of theObject is equal to "emerging" then
		setEmerging()
	else if the name of theObject is equal to "knocking" then
		setPortKnocking()
	else if the name of theObject is equal to "setpassword" then
		setPortKnockingPWD()
		----------------------------------
	else if the name of theObject is equal to "editlist" then
		renameList()
	else if the name of theObject is equal to "rename" then
		doRenameList()
	else if the name of theObject is equal to "addpreset" then
		set the contents of text field "addpreset" of window "addpreset" to ""
		set the contents of text field "description" of window "addpreset" to ""
		display panel window "addpreset" attached to window "main"
	else if the name of theObject is equal to "createpreset" then
		doCreatePreset()
	else if the name of theObject is equal to "delpreset" then
		deletePreset()
	else if the name of theObject is equal to "enablepreset" then
		enablePreset()
	else if the name of theObject is equal to "enablep" then
		showPresetConfirm()
	else if the name of theObject is equal to "donepreset" then
		updateInterface()
		updateContent()
		updateServices()
		close panel window "donepreset"
	else if the name of theObject is equal to "stats" then
		try
			set the contents of text field "loginfo" of tab view item "logs" of tab view "logstools" of window "logstools" to ("Size: " & (do shell script "ls -lh /var/log/pffirewall.log |awk '{print $5}'" with administrator privileges))
			set the contents of text view "logs" of scroll view "logs" of tab view item "logs" of tab view "logstools" of window "logstools" to do shell script "cat /var/log/pffirewall.log" with administrator privileges
		on error
			set the contents of text view "logs" of scroll view "logs" of tab view item "logs" of tab view "logstools" of window "logstools" to "/var/log/pffirewall.log file empty or not found."
			
		end try
		show window "logstools"
	else if the name of theObject is equal to "delservicehidden" then
		delServiceHidden()
	else if the name of theObject is equal to "sethiddenpassword" then
		try
			set the contents of text field "pass1" of window "setpassword" to do shell script "cat \"" & appdir & "default/SERVICES/hiddenpwd\" |sed -n '1p'"
			set the contents of text field "pass2" of window "setpassword" to do shell script "cat \"" & appdir & "default/SERVICES/hiddenpwd\" |sed -n '2p'"
			set the contents of text field "pass3" of window "setpassword" to do shell script "cat \"" & appdir & "default/SERVICES/hiddenpwd\" |sed -n '3p'"
		end try
		display panel window "setpassword" attached to window "main"
	else if the name of theObject is equal to "setpassword" then
		setPortKnockingPWD()
	else if the name of theObject is equal to "dummynet" then
		setDummynet()
	else if the name of theObject is equal to "opendrawer" then
		showDrawer()
	else if the name of theObject is equal to "closedrawer" then
		tell drawer "maindrawer" of window "main" to close drawer
	end if
	--
end clicked


on choose menu item theObject
	if the name of theObject is equal to "import" then
		importConf()
	else if the name of theObject is equal to "export" then
		exportConf()
	else if the name of theObject is equal to "license" then
		show window "license"
	else if the name of theObject is equal to "direction" then
		updateInterface()
		updateContent()
		updateServices()
		
	end if
end choose menu item

-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					AWAKE FROM NIB
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- AWAKE FROM NIB
on awake from nib theObject
	if the name of theObject is equal to "lists" then
		set theDataSource to make new data source at end of data sources with properties {name:"lists"}
		-- Create the data columns
		make new data column at end of data columns of theDataSource with properties {name:"lists", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		-- Set the data source as sorted
		set sorted of theDataSource to false
		-- Set the "item" data column as the sort column
		set sort column of theDataSource to data column "lists" of theDataSource
		-- Finally, assign the data source of the table view to our data source
		set data source of theObject to theDataSource
		--
		updateInterface() -- update group column
		updateContent() -- update addresses column
		updateServices() -- update allowed services column
		
		
		
	else if the name of theObject is equal to "content" then
		set theDataSource to make new data source at end of data sources with properties {name:"content"}
		-- Create the data columns
		make new data column at end of data columns of theDataSource with properties {name:"content", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		-- Set the data source as sorted
		set sorted of theDataSource to false
		-- Set the "item" data column as the sort column
		set sort column of theDataSource to data column "content" of theDataSource
		-- Finally, assign the data source of the table view to our data source
		set data source of theObject to theDataSource
	else if the name of theObject is equal to "services" then
		set theDataSource to make new data source at end of data sources with properties {name:"services"}
		-- Create the data columns
		make new data column at end of data columns of theDataSource with properties {name:"services", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		-- Set the data source as sorted
		set sorted of theDataSource to false
		-- Set the "item" data column as the sort column
		set sort column of theDataSource to data column "services" of theDataSource
		-- Finally, assign the data source of the table view to our data source
		set data source of theObject to theDataSource
	else if the name of theObject is equal to "servicedb" then
		set theDataSource to make new data source at end of data sources with properties {name:"servicedb"}
		-- Create the data columns
		make new data column at end of data columns of theDataSource with properties {name:"id", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
		make new data column at end of data columns of theDataSource with properties {name:"service", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		make new data column at end of data columns of theDataSource with properties {name:"protocol", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		make new data column at end of data columns of theDataSource with properties {name:"ports", sort order:ascending, sort type:numerical, sort case sensitivity:case sensitive}
		-- Set the data source as sorted
		set sorted of theDataSource to true
		-- Set the "item" data column as the sort column
		set sort column of theDataSource to data column "id" of theDataSource
		-- Finally, assign the data source of the table view to our data source
		set data source of theObject to theDataSource
	else if the name of theObject is equal to "presets" then
		set theDataSource to make new data source at end of data sources with properties {name:"presets"}
		-- Create the data columns
		make new data column at end of data columns of theDataSource with properties {name:"presets", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		-- Set the data source as sorted
		set sorted of theDataSource to false
		-- Set the "presets" data column as the sort column
		set sort column of theDataSource to data column "presets" of theDataSource
		-- Finally, assign the data source of the table view to our data source
		set data source of theObject to theDataSource
	else if the name of theObject is equal to "serviceshidden" then
		set theDataSource to make new data source at end of data sources with properties {name:"serviceshidden"}
		-- Create the data columns
		make new data column at end of data columns of theDataSource with properties {name:"serviceshidden", sort order:ascending, sort type:alphabetical, sort case sensitivity:case sensitive}
		-- Set the data source as sorted
		set sorted of theDataSource to false
		-- Set the "presets" data column as the sort column
		set sort column of theDataSource to data column "serviceshidden" of theDataSource
		-- Finally, assign the data source of the table view to our data source
		set data source of theObject to theDataSource
		updateKnocking()
	end if
end awake from nib


-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					APPLICATION LAUNCH
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- APPLICATION LAUNCH
on launched theObject
	-- CHECK IF CURRENT USER IS ADMIN, IF NOT THEN QUIT
	set userType to do shell script "if groups $USER | grep &>/dev/null '\\badmin\\b'; then echo \"admin\" ; fi"
	if userType is not equal to "admin" then
		displayDialogOK("Sorry, PFLists can be used only by administrators. If you are an administrator please login with an admin user/password at OS X login screen and relaunch PFLists.")
		try
			do shell script "killall PFLists"
		end try
		quit
	end if
	--
	getPath() -- get path for current app bundle
	-- CHECK IF PFLISTS IS INSIDE APPLICATIONS DIRECTORY
	if binaryPath does not start with "/Applications" then
		--
		set question to display dialog "PFLists should be run from /Applications directory. You should quit now, move PFLists to /Applications directory and restart PFLists. Continue anyway? " buttons {"Yes", "No, quit"} default button 1
		set answer to button returned of question
		if answer is equal to "No, quit" then
			try
				do shell script "killall PFLists"
			end try
			quit
			
		end if
	end if
	
	
	tell tab view "main" of window "main"
		set current tab view item to tab view item "help"
	end tell
	tell progress indicator "spinner" of window "emerging" to start
	--
	getPath() -- get path for current app bundle
	checkOSXversion() -- check for OS X version
	if macosxVersion is equal to "10.7" then
		set the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		set the enabled of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
	end if
	if macosxVersion is equal to "10.10" then
		set the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		set the enabled of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
	end if
	if macosxVersion is equal to "10.11" then
		set the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		set the enabled of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
	end if
	if macosxVersion is equal to "10.11" then
		set the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		set the enabled of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
	end if
	networkSettings() -- get local ip, mask and net address for the main interface (egress)
	checkPFonInstall() -- check if PF is running when installing pflists
	checkWorkingDirectory() -- check if local db structure exists
	checkPFstatus() -- check the status of PF firewall (enabled/disabled, pfctl -si)
	checkOptions() -- check saved options and set interface accordingly
	-- get pflists bundle version
	set PFListsBuild to do shell script "cat \"" & binaryPath & "../Info.plist\" |head -24 |tail -1 |cut -d \">\" -f2 |cut -d \"<\" -f1"
	set PFListsVersion to do shell script "cat \"" & binaryPath & "../Info.plist\" |head -20 |tail -1 |cut -d \">\" -f2 |cut -d \"<\" -f1"
	set the contents of text field "bannerversion" of tab view item "help" of tab view "main" of window "main" to "V " & PFListsVersion & " (build " & PFListsBuild & ")"
	set the visible of text field "maskfield" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	updateServiceDB()
	set firstClick to "0"
end launched

-- CHECK IF WORKING DIRECTORY EXISTS .. IF NOT WE INSTALL EVERYTHING
on checkWorkingDirectory()
	try
		do shell script "ls \"" & appdir & "\""
	on error
		tell progress indicator "spinner" of window "welcome" to start
		display panel window "welcome" attached to window "main"
		buildWorkingDirectory()
		-- purge app bundle from apple gatekeeper PureShit®™ file attributes
		try
			do shell script "xattr -c " & binaryPath & "*" with administrator privileges
		on error errorTxt
			
		end try
	end try
end checkWorkingDirectory

-- CHECK IF PF IS ENABLED WHEN INSTALLING (in case: disable pf and uninstall scripts)
on checkPFonInstall()
	try
		do shell script "ls \"" & appdir & "\""
	on error
		try
			-- check if PF is enabled
			set pfstatus to do shell script "pfctl -si |grep \"Status:\" |awk '{print $2}'" with administrator privileges
			if pfstatus is equal to "Enabled" then
				set question to display dialog "To install PFLists we must temporary disable the PF firewall. Configure and start PFLists to reenable the PF firewall." buttons {"Continue", "Abort"} default button 1
				set answer to button returned of question
				if answer is equal to "Abort" then
					quit
				else
					do shell script "pfctl -d" with administrator privileges -- disable pf
					-- delete startup scripts (icefloor, pflists)
					do shell script "rm -f /Library/LaunchDaemons/com.hanynet.icefloor.plist" with administrator privileges
					do shell script "rm -f /etc/icefloor.sh" with administrator privileges
				end if
			end if
		end try
	end try
end checkPFonInstall


-- BUILD WORKING DIRECTORY 
on buildWorkingDirectory()
	try
		do shell script "rm -rf \"" & appdir & "\"" with administrator privileges
		-- make working directory (where pflists stores its preferences file/folder structure) 
		do shell script "mkdir \"" & appdir & "\"" with administrator privileges
		-- change rwad/write permissions, allow owner and group to read and write
		do shell script "chmod -R ug+rw \"" & appdir & "\"" with administrator privileges
		-- change group for directory, assign 'admin' as group. All admins will have read/write access to working dir
		do shell script "chgrp admin \"" & appdir & "\"" with administrator privileges
		-- install info
		set dateSinceEpoch to do shell script "date +%s"
		set currentDate to do shell script "date"
		set PFListsBuild to do shell script "cat \"" & binaryPath & "../Info.plist\" |head -24 |tail -1 |cut -d \">\" -f2 |cut -d \"<\" -f1"
		set PFListsVersion to do shell script "cat \"" & binaryPath & "../Info.plist\" |head -20 |tail -1 |cut -d \">\" -f2 |cut -d \"<\" -f1"
		set installUserName to do shell script "echo $USER"
		do shell script "echo \"PFLists\" > \"" & appdir & "install-info\""
		do shell script "echo \"build:" & PFListsBuild & "\" >> \"" & appdir & "install-info\""
		do shell script "echo \"Installed by " & installUserName & " using PFLists " & PFListsVersion & " build " & PFListsBuild & " on " & currentDate & " (epoch: " & dateSinceEpoch & ")\" >> \"" & appdir & "install-info\""
	end try
	try
		
		-- make dir for default configuration
		do shell script "mkdir \"" & appdir & "default\""
		-- make subdirs
		do shell script "mkdir \"" & appdir & "default/LISTS\""
		do shell script "mkdir \"" & appdir & "default/OPTIONS\""
		do shell script "mkdir \"" & appdir & "default/SERVICES\""
		-- copy default option file
		do shell script "cp \"" & binaryPath & "options\" \"" & appdir & "default/OPTIONS/\""
		-- create ruleset name
		do shell script "echo \"Default PFLists configuration # Allow my local network to connect to my shared documents, photos, music and usb printers. Block everything else. Allow all outbound connections.\" > \"" & appdir & "default/OPTIONS/description\""
		-- copy servicedb from app bundle
		do shell script "cp \"" & binaryPath & "servicedb\" \"" & appdir & "default/SERVICES\""
		-- make _any group
		do shell script "mkdir \"" & appdir & "default/LISTS/_any\""
		-- make _any group content and services
		do shell script "echo \"@0.0.0.0/0-\" > \"" & appdir & "default/LISTS/_any/content\""
		do shell script "echo \"@::/0-\" >> \"" & appdir & "default/LISTS/_any/content\""
		do shell script "touch \"" & appdir & "default/LISTS/_any/services\""
		do shell script "echo \"00002#Essential system services#all#53 67 68 123 389 636 5353 5354\" >> \"" & appdir & "default/LISTS/_any/services\""
		-- make my_local_network group
		do shell script "mkdir \"" & appdir & "default/LISTS/my_local_network\""
		-- make my_local_network group content
		do shell script "echo \"@" & LocalNetworkAddress & "-\" > \"" & appdir & "default/LISTS/my_local_network/content\""
		-- make my_local_network group services
		do shell script "touch \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00003#Apple file sharing#tcp#548 88\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00004#Windows file sharing#all#137 138 139 445\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00006#Printer sharing#tcp#631 515 9100\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00007#iTunes sharing#all#3689 554 5353 123\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00008#iPhoto sharing#all#8770\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00019#iChat, Facetime, Game Center#all#16403:16472 16393:16402 16384:16403 3261 5190 5222 5269 5297 5298 5678 7777\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		do shell script "echo \"00034#ICMP protocol#icmp#\" >> \"" & appdir & "default/LISTS/my_local_network/services\""
		-- make _blacklist group
		do shell script "mkdir \"" & appdir & "default/LISTS/_blacklist\""
		-- make _any group content and services
		do shell script "touch \"" & appdir & "default/LISTS/_blacklist/services\""
		do shell script "touch \"" & appdir & "default/LISTS/_blacklist/content\""
		-- make _outbound group
		do shell script "mkdir \"" & appdir & "default/LISTS/_outbound\""
		-- make _outbound group content and services
		do shell script "echo \"@0.0.0.0/0-\" > \"" & appdir & "default/LISTS/_outbound/content\""
		do shell script "echo \"@::/0-\" >> \"" & appdir & "default/LISTS/_outbound/content\""
		do shell script "echo \"00001#All services (tcp,udp)#all#1:65535\" >> \"" & appdir & "default/LISTS/_outbound/services\""
		do shell script "echo \"00034#ICMP protocol#icmp#\" >> \"" & appdir & "default/LISTS/_outbound/services\""
		do shell script "echo \"00037#IPV6-ICMP protocol#ipv6-icmp#\" >> \"" & appdir & "default/LISTS/_outbound/services\""
		do shell script "echo \"00035#IGMP protocol#igmp#\" >> \"" & appdir & "default/LISTS/_outbound/services\""
		-- create presets directory
		do shell script "mkdir \"" & appdir & "presets\""
		-- copy logging exceptions configuration file
		do shell script "cp \"" & binaryPath & "exceptions\" \"" & appdir & "default/OPTIONS/exceptions\""
		-- create port knocking service list file
		do shell script "touch \"" & appdir & "default/SERVICES/hidden\""
		-- create port knocking password file
		do shell script "touch \"" & appdir & "default/SERVICES/hiddenpwd\""
		do shell script "echo \"11111\" >> \"" & appdir & "default/SERVICES/hiddenpwd\""
		do shell script "echo \"22222\" >> \"" & appdir & "default/SERVICES/hiddenpwd\""
		do shell script "echo \"33333\" >> \"" & appdir & "default/SERVICES/hiddenpwd\""
		-- create dummynet bandwidth file
		do shell script "touch \"" & appdir & "default/OPTIONS/dummynet\""
		-- create custom rules file
		do shell script "touch \"" & appdir & "default/OPTIONS/customrules\""
		-- create NAT options file
		do shell script "touch \"" & appdir & "default/OPTIONS/nat\""
		-- create RDR options file
		do shell script "touch \"" & appdir & "default/OPTIONS/rdr\""
		-----------------------------------------
		-- backup default configuration to presets
		do shell script "cp -R \"" & appdir & "default\" \"" & appdir & "presets/default\""
		-- copy default presets
		do shell script "cp -R \"" & binaryPath & "presets.zip\" \"" & appdir & "presets/\""
		do shell script "cd \"" & appdir & "presets\" ; unzip presets.zip ; rm -f presets.zip"
		-----------------------------------------
		set the enabled of button "closewelcome" of window "welcome" to true as boolean
		tell progress indicator "spinner" of window "welcome" to stop
	on error errorText
		tell progress indicator "spinner" of window "welcome" to stop
		displayDialogOK("Error installing PFLists: " & errorText & ". PFLists will now quit")
		quit
	end try
end buildWorkingDirectory

-- restore service database
on restoreServiceDB()
	-- copy servicedb from app bundle
	do shell script "cp \"" & binaryPath & "servicedb\" \"" & appdir & "default/SERVICES\""
end restoreServiceDB

-- check PF status
on checkPFstatus()
	try
		set pfstatus to do shell script "pfctl -si |grep \"Status:\" |awk '{print $2}'" with administrator privileges
		if pfstatus is equal to "Enabled" then
			set the contents of text field "bannerfirewall" of tab view item "firewall" of tab view "main" of window "main" to ""
			enableStop()
		else if pfstatus is equal to "Disabled" then
			set the contents of text field "bannerfirewall" of tab view item "firewall" of tab view "main" of window "main" to ""
			enableStart()
		end if
	end try
end checkPFstatus

-- CHECK OPTIONS (read pflists options file and set interface accordingly)

on checkOptions()
	-- COM.APPLE option
	try
		set comAppleOption to do shell script "cat \"" & appdir & "default/OPTIONS/options\" |grep \"comapple\" |cut -d \":\" -f 2"
		if comAppleOption is equal to "1" then
			set the content of button "comapple" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to true as boolean
		else
			set the content of button "comapple" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		end if
	end try
	-- DUMMYNET BANDWIDTH option
	try
		set dummynetOption to ""
		set dummynetOption to do shell script "cat \"" & appdir & "default/OPTIONS/dummynet\""
		if dummynetOption is equal to "" then
			set the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		else
			set the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to true as boolean
			set the content of text field "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to dummynetOption
		end if
	end try
	-- EMERGING THREATS option
	try
		set emergingOption to do shell script "cat \"" & appdir & "default/OPTIONS/options\" |grep \"emerging\" |cut -d \":\" -f 2"
		if emergingOption is equal to "1" then
			set the content of button "emerging" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to true as boolean
		else
			set the content of button "emerging" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" to false as boolean
		end if
	end try
	-- LOGGING EXCEPTIONS 
	try
		set the contents of text field "inboundtcp" of window "exceptions" to do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"inboundtcp\" |cut -d \"#\" -f 2"
		set the contents of text field "outboundtcp" of window "exceptions" to do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"outboundtcp\" |cut -d \"#\" -f 2"
		set the contents of text field "inboundudp" of window "exceptions" to do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"inboundudp\" |cut -d \"#\" -f 2"
		set the contents of text field "outboundudp" of window "exceptions" to do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"outboundudp\" |cut -d \"#\" -f 2"
		set the contents of text field "ignoredips" of window "exceptions" to do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"ignoredips\" |cut -d \"#\" -f 2"
		set the contents of button "ignoredicmp" of window "exceptions" to (do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"ignoredicmp\" |cut -d \"#\" -f 2") as boolean
		set the contents of button "ignoredicmp6" of window "exceptions" to (do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"ignored6icmp\" |cut -d \"#\" -f 2") as boolean
		set the contents of button "ignoredigmp" of window "exceptions" to (do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"ignoredigmp\" |cut -d \"#\" -f 2") as boolean
		set the contents of button "ignoredipv6" of window "exceptions" to (do shell script "cat \"" & appdir & "default/OPTIONS/exceptions\" |grep \"ignoredipv6\" |cut -d \"#\" -f 2") as boolean
	end try
	-- PORT KNOCKING
	try
		set knockingOption to do shell script "cat \"" & appdir & "default/OPTIONS/options\" |grep \"knocking\" |cut -d \":\" -f 2"
		if knockingOption is equal to "1" then
			set the content of button "knocking" of tab view item "knocking" of tab view "main" of window "main" to true as boolean
		else
			set the content of button "knocking" of tab view item "knocking" of tab view "main" of window "main" to false as boolean
		end if
	end try
end checkOptions






-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
-- START BUTTON
on enableStart()
	set the visible of button "apply" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	set the visible of button "enablep" of tab view item "presets" of tab view "main" of window "main" to false as boolean
	
	set the title of button "startstop" of tab view item "firewall" of tab view "main" of window "main" to "Start"
	set the visible of image view "picon" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	set the visible of image view "picoff" of tab view item "firewall" of tab view "main" of window "main" to true as boolean
	set the visible of image view "picerr" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	set the visible of image view "picmid" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
end enableStart
--
on enableStop()
	set the visible of button "apply" of tab view item "firewall" of tab view "main" of window "main" to true as boolean
	set the visible of button "enablep" of tab view item "presets" of tab view "main" of window "main" to true as boolean
	
	set the title of button "startstop" of tab view item "firewall" of tab view "main" of window "main" to "Stop"
	set the visible of image view "picon" of tab view item "firewall" of tab view "main" of window "main" to true as boolean
	set the visible of image view "picoff" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	set the visible of image view "picerr" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	set the visible of image view "picmid" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
end enableStop



-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
-- RESTORE DB
on restoreDB()
	set question to display dialog "Are you sure you want to restore the default PFLists services database? All your custom services will be lost. Proceed?" buttons {"Yes", "No"} default button 1
	set answer to button returned of question
	if answer is equal to "yes" then
		restoreServiceDB()
		updateServiceDB()
	end if
end restoreDB



-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

--
on activated theObject
	(*Add your script here.*)
end activated

--
on will quit theObject
	(*Add your script here.*)
end will quit

-- ADD SELECTED SERVICE TO SELECTED LIST (double click ServiceDB table)
on double clicked theObject
	
end double clicked


-- selection changed
on selection changed theObject
	--displayDialogOK("selection change")
	if the name of theObject is equal to "lists" then
		try
			updateContent()
			updateServices()
		end try
	else if the name of theObject is equal to "presetstable" then
		set tableView to table view "presetstable" of scroll view "presets" of tab view item "presets" of tab view "main" of window "main"
		try
			set selectedRow to selected row of tableView
			set presetName to the contents of data cell "presets" of selected data row of tableView
			--
			set theDescr to do shell script "cat \"" & appdir & "presets/" & presetName & "/OPTIONS/description\""
			set the contents of text field "description" of tab view item "presets" of tab view "main" of window "main" to theDescr
		on error
			-- display description of first preset in list
			set presetsList to do shell script "ls \"" & appdir & "presets\" | grep -v __MACOSX"
			set presetName to paragraph 1 of presetsList
			set theDescr to do shell script "cat \"" & appdir & "presets/" & presetName & "/OPTIONS/description\""
			set the contents of text field "description" of tab view item "presets" of tab view "main" of window "main" to theDescr
			
		end try
	end if
end selection changed

on should close theObject
	quit
end should close

on selected tab view item theObject tab view item tabViewItem
	try
		if the name of theObject is equal to "main" then
			if the name of tabViewItem is equal to "firewall" then
				updateServices()
				if firstClick is equal to "0" then
					try
						set firstClick to "1"
						updateInterface()
						updateContent()
						--updateServices()
						updateKnocking()
					end try
				end if
			end if
			if the name of tabViewItem is equal to "presets" then
				updatePresetsList()
			end if
			if the name of tabViewItem is equal to "knocking" then
				updateKnocking()
			end if
		end if
	end try
end selected tab view item







-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					INTERFACE
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- UPDATE INTERFACE (PFLISTS MAIN WINDOW CONTENT)
on updateInterface()
	
	--------- LISTS
	try
		set selectedListsRow to (selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main")
		
		set theTableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set the content of theTableView to {}
		set theDataSource to data source of theTableView
		-- count lists (count directories in LISTS directory)
		set listsCount to do shell script "ls \"" & appdir & "default/LISTS/\"" & " |wc -l |bc"
		----------------------------------------------------------
		---------- remove _outbound from count
		if the title of popup button "direction" of tab view item "firewall" of tab view "main" of window "main" is equal to "inbound" then
			set listsCount to listsCount - 1
			-- get lists list (used with parser in 'repeat')
			set listsList to do shell script "ls -l \"" & appdir & "default/LISTS/\"" & " |grep -v _outbound |awk '{print $9}' |sed '/./,$!d'"
		else -- outbound!
			set listsList to do shell script "ls -l \"" & appdir & "default/LISTS/\"" & " |grep _outbound |awk '{print $9}' |sed '/./,$!d'"
		end if
		-----------------------------------------------------
		-- OLD
		---set listsList to do shell script "ls -l " & appdir & "default/LISTS/" & " |awk '{print $9}' |sed '/./,$!d'"
		-- loop
		repeat with loopCounter from 1 to listsCount
			-- lists all directories (each dir is a PFLists list)
			set listName to paragraph loopCounter of listsList
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "lists" of theTask to listName
		end repeat
		set selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main" to (selectedListsRow)
	end try
	--- PRESET NAME
	try
		set currentPresetDescription to do shell script "cat \"" & appdir & "default/OPTIONS/description\" | cut -d \"#\" -f 1"
		set the contents of text field "currentpreset" of tab view item "firewall" of tab view "main" of window "main" to "Current preset: " & currentPresetDescription
	on error
		set the contents of text field "currentpreset" of tab view item "firewall" of tab view "main" of window "main" to ""
		
		
	end try
end updateInterface

on updateContent()
	try
		set the content of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main" to {}
		--------- CONTENT
		-- get selected list name
		set theTableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set selectedRow to selected row of theTableView
		set listName to the contents of data cell "lists" of selected data row of theTableView
		--displayDialog("updateContent with table: " & listName)
		-- get selected list content from file
		set listContent to ""
		set listContent to do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/content\""
		-- count Content lines
		set contentLines to count paragraph of listContent
		-- content table
		set theTableView to table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main"
		set the content of theTableView to {}
		set theDataSource to data source of theTableView
		set the contents of text field "banner_addcontent" of window "addcontent" to "Add IP and/or network addresses to group " & listName
		-- loop
		repeat with loopCounter from 1 to contentLines
			set theContent to paragraph loopCounter of listContent
			set theContent to (characters 2 thru ((length of theContent) - 1) of theContent) as string
			
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "content" of theTask to theContent
		end repeat
	end try
end updateContent

on updateServices()
	
	try
		set the content of table view "services" of scroll view "services" of tab view item "firewall" of tab view "main" of window "main" to {}
		--------- SERVICES
		-- get selected list name
		set theTableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set selectedRow to selected row of theTableView
		set listName to the contents of data cell "lists" of selected data row of theTableView
		-- get selected list services from file
		set listServiceDB to ""
		set listServiceDB to do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\""
		--set servicesCount to do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\" |wc -l |bc"
		set servicesCount to count paragraph of listServiceDB
		set theTableView to table view "services" of scroll view "services" of tab view item "firewall" of tab view "main" of window "main"
		set the content of theTableView to {}
		set theDataSource to data source of theTableView
		set the contents of text field "banner_addservice" of window "addservice" to "Double click to add selected service to group " & listName
		-- loop
		set AppleScript's text item delimiters to {"#"}
		repeat with loopCounter from 1 to servicesCount
			set theParagraph to paragraph loopCounter of listServiceDB
			set theServiceName to text item 2 of theParagraph
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "services" of theTask to theServiceName
		end repeat
		set AppleScript's text item delimiters to {""}
	end try
	
end updateServices


-- port knocking services table
on updateKnocking()
	--displayDialogOK("updating knocking")
	try
		set the content of table view "serviceshidden" of scroll view "serviceshidden" of tab view item "knocking" of tab view "main" of window "main" to {}
		--------- HIDDEN SERVICES
		-- get selected list services from file
		set listHiddenServices to ""
		set listHiddenServices to do shell script "cat \"" & appdir & "default/SERVICES/hidden\""
		set servicesCount to count paragraph of listHiddenServices
		set theTableView to table view "serviceshidden" of scroll view "serviceshidden" of tab view item "knocking" of tab view "main" of window "main"
		set the content of theTableView to {}
		set theDataSource to data source of theTableView
		-- loop
		set AppleScript's text item delimiters to {"#"}
		repeat with loopCounter from 1 to servicesCount
			set theParagraph to paragraph loopCounter of listHiddenServices
			set theServiceName to text item 2 of theParagraph
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "serviceshidden" of theTask to theServiceName
		end repeat
		set AppleScript's text item delimiters to {""}
	end try
end updateKnocking











-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					LISTS
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- ADD LIST
on addList()
	if the title of popup button "direction" of tab view item "firewall" of tab view "main" of window "main" is equal to "inbound" then
		display panel window "addlist" attached to window "main"
	else
		displayDialogOK("Sorry, you can't add any group to outbound list, please use default _outbound group or add a new group to inbound list.")
	end if
end addList

-- DELETE SELECTED LIST
on delList()
	set selectedListsRow to (selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main")
	try
		-- get selected list name
		set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set selectedRow to selected row of tableView
		set listName to the contents of data cell "lists" of selected data row of tableView
		-- check list name
		if listName is equal to "_any" or listName is equal to "_blacklist" or listName is equal to "_outbound" then
			displayDialogOK("Sorry, you can't delete this group because PFLists needs it. You can however remove all services assigned to this group in order to disable it.")
		else
			set question to display dialog "Are you sure you want to delete group " & listName & "?" buttons {"Yes", "No"} default button 1
			set answer to button returned of question
			if answer is equal to "yes" then
				-- delete directory (delete selected list)
				do shell script "rm -rf \"" & appdir & "default/LISTS/" & listName & "\""
				-- update
				updateInterface()
				updateContent()
				updateServices()
				doModifyPreset()
			end if
		end if
	end try
	set selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main" to "1"
end delList

-- RENAME LIST
on renameList()
	
	-- get selected list name
	set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set listName to the contents of data cell "lists" of selected data row of tableView
	-- check list name
	if listName is equal to "_any" or listName is equal to "_blacklist" or listName is equal to "_outbound" then
		displayDialogOK("Sorry, you can't rename group " & listName)
	else
		set the contents of text field "listname" of window "rename" to listName
		display panel window "rename" attached to window "main"
	end if
end renameList
-- RENAME IT
on doRenameList()
	try
		set listName to the contents of text field "listname" of window "rename"
		set newListName to the contents of text field "rename" of window "rename"
		set newListName to do shell script "echo \"" & newListName & "\" |sed 's/ /_/g'" -- remove spaces
		
		do shell script "cp -R \"" & appdir & "default/LISTS/" & listName & "\" \"" & appdir & "default/LISTS/" & newListName & "\""
		do shell script "rm -rf \"" & appdir & "default/LISTS/" & listName & "\""
	end try
	-- update interface
	updateInterface()
	updateContent()
	updateServices()
	set DataRows to count data rows of (data source of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main")
	set selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main" to "1"
	set startApp to "1"
	set the contents of text field "rename" of window "rename" to ""
	close panel window "rename"
	doModifyPreset()
end doRenameList




-- ADD DEFINED LIST AS NEW LIST
on addTheList()
	set selectedListsRow to (selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main")
	try
		-- list name
		set theListName to the contents of text field "addlist" of window "addlist"
		-- purge spaces
		set theListName to do shell script "echo \"" & theListName & "\" |sed 's/ /_/g'"
		-- create list directory
		do shell script "mkdir \"" & appdir & "default/LISTS/" & theListName & "\""
		-- create content file for the list
		do shell script "touch \"" & appdir & "default/LISTS/" & theListName & "/content\""
		-- create services file for the list
		do shell script "touch \"" & appdir & "default/LISTS/" & theListName & "/services\""
		-- close addlist window
		close panel window "addlist"
	on error errorText
		displayDialogOK("Error: " & errorText)
	end try
	-- popup message
	--displayDialogOK("List " & contents of text field "addlist" of window "addlist" & " added.")
	-- clean addlist window
	set the contents of text field "addlist" of window "addlist" to ""
	-- update interface
	updateInterface()
	
	updateContent()
	updateServices()
	set DataRows to count data rows of (data source of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main")
	set selected row of table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main" to "1"
	doModifyPreset()
end addTheList



-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					CONTENT
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- ADD CONTENT
on addContent()
	-- get selected list name
	set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set listName to the contents of data cell "lists" of selected data row of tableView
	-- empty field
	set the contents of text field "addcontent" of window "addcontent" to ""
	if listName is equal to "_any" or listName is equal to "_outbound" then
		displayDialogOK("Sorry, you can't add addresses to group " & listName)
	else
		-- set banner
		display panel window "addcontent" attached to window "main"
		set the contents of text field "banner_addcontent" of window "addcontent" to "Add IP and/or network addresses to group " & listName
	end if
end addContent


-- ADD SELECTED CONTENT 
on addTheContent()
	try
		set selectedContentRow to (selected row of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main")
		
		-- get selected list name
		set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set selectedRow to selected row of tableView
		set listName to the contents of data cell "lists" of selected data row of tableView
		-- get content to add
		set newContent to the contents of text field "addcontent" of window "addcontent"
		-- verify content
		set verifyContent to do shell script "echo \"" & newContent & "\" |sed 's/ //g'"
		if verifyContent is equal to "" then
			displayDialogOK("Address can't be empty.")
		else
			-- add content to selected list's content file
			do shell script "echo \"" & newContent & "\" |sed 's/^ *//;s/ *$//;s/ \\{1,\\}/ /g' |tr \" \" \"\\n\" | sed 's/.*/&-/' |sed 's/^/@/' >> \"" & appdir & "default/LISTS/" & listName & "/content\""
		end if
	on error errorText
		displayDialogOK("Error: " & errorText)
	end try
	close panel window "addcontent"
	updateContent()
	set DataRows to count data rows of (data source of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main")
	set selected row of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main" to (DataRows)
	doModifyPreset()
end addTheContent

-- DELETE SELECTED CONTENT FROM SELECTED LIST
on delContent()
	set selectedContentRow to (selected row of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main")
	
	try
		-- get selected list name
		set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set selectedRow to selected row of tableView
		set listName to the contents of data cell "lists" of selected data row of tableView
		-- check list name
		if listName is equal to "_any" or listName is equal to "_outbound" then
			displayDialogOK("Sorry, you can't delete addresses from group " & listName)
		else
			-- get selected content
			set tableView to table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main"
			set selectedRow to selected row of tableView
			set selectedContent to the contents of data cell "content" of selected data row of tableView
			--
			set selectedContent to "@" & selectedContent & "-"
			-- delete content from selected list's 'content' file
			do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/content\" | grep -v \"" & selectedContent & "\" | sed '/^$/d' > /tmp/pflists.tmp"
			do shell script "cp /tmp/pflists.tmp \"" & appdir & "default/LISTS/" & listName & "/content\""
			do shell script "rm -f /tmp/pflists.tmp"
			-- update
			updateContent()
			doModifyPreset()
		end if
	end try
	if selectedContentRow is equal to 1 then
		set selected row of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main" to 1
	else
		set selected row of table view "content" of scroll view "content" of tab view item "firewall" of tab view "main" of window "main" to (selectedContentRow - 1)
	end if
end delContent


-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					SERVICES
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
-- ADD A NEW SERVICE - NOT USED !!
on addService()
	--try 
	display panel window "addservice" attached to window "main"
	updateServiceDB()
	-- get selected list name
	set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set listName to the contents of data cell "lists" of selected data row of tableView
	-- set banner
	set the contents of text field "banner_addservice" of window "addservice" to "Double click to add selected service to group " & listName
	--end try
end addService

-- ADD SELECTED SERVICE TO SELECTED LIST'S SERVICES (old way from Database window double click) NOT USED !!!
on addTheService()
	-- get selected list name
	set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set listName to the contents of data cell "lists" of selected data row of tableView
	if listName is equal to "_blacklist" then
		displayDialogOK("You can't add services to _blacklist group. All traffic from/to this group is blocked.")
	else
		-- get service id from serviceDB table
		set theTableView to table view "servicedb" of scroll view "servicedb" of window "addservice"
		set theDataSource to data source of theTableView
		set selectedRow to selected row of theTableView
		set selectedServiceID to the contents of data cell "id" of selected data row of theTableView
		--
		set serviceRow to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" |grep \"" & selectedServiceID & "#\""
		--check if service already exists in selected list
		set theCheck to ""
		try
			set theCheck to do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\" |grep \"" & serviceRow & "\""
		end try
		if theCheck is not equal to "" then
			set question to display dialog "Service already added to this list." buttons {"Cancel"} default button 1
			
		else
			do shell script "echo \"" & serviceRow & "\" >> \"" & appdir & "default/LISTS/" & listName & "/services\""
			updateServices()
		end if
	end if
end addTheService

-- ADD SELECTED SERVICE TO SELECTED LIST'S SERVICES (new way from popup menu)
on addTheServicePopup()
	-- get selected list name
	set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set listName to the contents of data cell "lists" of selected data row of tableView
	if listName is equal to "_blacklist" then
		displayDialogOK("You can't add services to _blacklist group. All traffic from/to this group is blocked.")
	else
		-- get service name
		set selectedServiceNAME to the title of current menu item of popup button "popup" of tab view item "firewall" of tab view "main" of window "main"
		-- make row to append to lists's services file
		set serviceRow to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" |grep \"#" & selectedServiceNAME & "#\""
		--check if service already exists in selected list
		set theCheck to ""
		try
			set theCheck to do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\" |grep \"" & serviceRow & "\""
		end try
		if theCheck is not equal to "" then
			displayDialogOK("Service <" & selectedServiceNAME & "> already added to this list.")
		else
			do shell script "echo \"" & serviceRow & "\" >> \"" & appdir & "default/LISTS/" & listName & "/services\""
			updateServices()
		end if
		set current menu item of popup button "popup" of tab view item "firewall" of tab view "main" of window "main" to menu item 1 of popup button "popup" of tab view item "firewall" of tab view "main" of window "main"
		doModifyPreset()
	end if
end addTheServicePopup


-- ACTION (POPUP SELECTION)
on action theObject
	if the name of theObject is equal to "popup" then
		addTheServicePopup() -- add selected service to current group
	else if the name of theObject is equal to "popuphidden" then
		addTheServicePopupHidden() -- add selected service to hidden services
	else if the name of theObject is equal to "pfmanpages" then
		if the title of current menu item of theObject is equal to "pfctl" then
			tell application "Terminal"
				activate
				do script with command "man pfctl"
			end tell
		else if the title of current menu item of theObject is equal to "pf.conf" then
			tell application "Terminal"
				activate
				do script with command "man pf.conf"
			end tell
		end if
		
	end if
end action

on changed theObject
	if the name of theObject is equal to "dummynet" then
		setDummynet()
	end if
end changed

on end editing theObject
	--	if the name of theObject is equal to "dummynet" then
	--	displayDialogOK("end editing")
	--	end if
end end editing

on should end editing theObject object anObject
	--if the name of theObject is equal to "dummynet" then
	--	--displayDialogOK("should end editing")
	setDummynet()
	--end if
end should end editing



-- DELETE SELECTED SERVICE FROM SELECTED GROUP'S LIST
on delService()
	set selectedServiceRow to (selected row of table view "services" of scroll view "services" of tab view item "firewall" of tab view "main" of window "main")
	
	try
		-- get selected list name
		set tableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
		set listName to the contents of data cell "lists" of selected data row of tableView
		-- get selected service
		set tableView to table view "services" of scroll view "services" of tab view item "firewall" of tab view "main" of window "main"
		set selectedService to the contents of data cell "services" of selected data row of tableView
		set selectedServiceID to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" |grep \"#" & selectedService & "#\" | cut -d \"#\" -f1"
		-- delete service from selected list's 'services' file
		do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\" | grep -v \"#" & selectedService & "#\" | sed '/^$/d' > /tmp/pflists2.tmp"
		do shell script "cp /tmp/pflists2.tmp \"" & appdir & "default/LISTS/" & listName & "/services\""
		do shell script "rm -f /tmp/pflists2.tmp"
		-- update
		updateServices()
	end try
	set selected row of table view "services" of scroll view "services" of tab view item "firewall" of tab view "main" of window "main" to (selectedServiceRow - 1)
	doModifyPreset()
end delService



-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					HIDDEN SERVICES - PORT KNOCKING
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- ADD SELECTED SERVICE TO HIDDEN SERVICES 
on addTheServicePopupHidden()
	try
		-- get service name
		set selectedHiddenServiceNAME to the title of current menu item of popup button "popuphidden" of tab view item "knocking" of tab view "main" of window "main"
		-- make row to append to lists's services file
		set serviceRow to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" |grep \"#" & selectedHiddenServiceNAME & "#\""
		set selectedID to do shell script "echo \"" & serviceRow & "\" | cut -d \"#\" -f1"
		--check if service already exists in selected list
		set theCheck to ""
		try
			set theCheck to do shell script "cat \"" & appdir & "default/SERVICES/hidden\" |grep \"" & serviceRow & "\""
		end try
		if theCheck is not equal to "" then
			displayDialogOK("Service <" & selectedHiddenServiceNAME & "> already added to Hidden Services.")
		else
			do shell script "echo \"" & serviceRow & "\" >> \"" & appdir & "default/SERVICES/hidden\""
			updateKnocking() -- update hidden services table to show added service
		end if
		-- HIDDEN SERVICE MUST BE DELETED FROM ALL INBOUND GROUPS
		-- delete service from all lists	
		try
			-- count lists (count directories in LISTS directory)
			set listsCount to do shell script "ls \"" & appdir & "default/LISTS/\"" & " |wc -l |bc"
			-- get lists list (used with parser in 'repeat')
			set listsList to do shell script "ls -l \"" & appdir & "default/LISTS/\"" & " |awk '{print $9}' |sed '/./,$!d'"
			
			-- loop
			repeat with loopCounter from 1 to listsCount
				try
					-- lists all directories (each dir is a PFLists list)
					set listName to paragraph loopCounter of listsList
					-- delete service from list's services
					do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\" | grep -v \"" & selectedID & "#\" | sed '/^$/d' > /tmp/pflists4.tmp"
					do shell script "cp /tmp/pflists4.tmp \"" & appdir & "default/LISTS/" & listName & "/services\""
					do shell script "rm -f /tmp/pflists4.tmp"
				end try
			end repeat
			
		on error errorTxt
			displayDialogOK("deleting error: " & errorTxt)
			
		end try
		
		set current menu item of popup button "popuphidden" of tab view item "knocking" of tab view "main" of window "main" to menu item 1 of popup button "popuphidden" of tab view item "knocking" of tab view "main" of window "main"
	on error errorTxt
		displayDialogOK("knocking error: " & errorTxt)
	end try
	doModifyPreset()
end addTheServicePopupHidden

-- DELETE SELECTED SERVICE FROM HIDDEN SERVICES LIST
on delServiceHidden()
	set selectedServiceRow to (selected row of table view "serviceshidden" of scroll view "serviceshidden" of tab view item "knocking" of tab view "main" of window "main")
	
	try
		-- get selected service
		set tableView to table view "serviceshidden" of scroll view "serviceshidden" of tab view item "knocking" of tab view "main" of window "main"
		set selectedService to the contents of data cell "serviceshidden" of selected data row of tableView
		set selectedServiceID to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" |grep \"#" & selectedService & "#\" | cut -d \"#\" -f1"
		-- delete service from hidden services' file
		do shell script "cat \"" & appdir & "default/SERVICES/hidden\" | grep -v \"#" & selectedService & "#\" | sed '/^$/d' > /tmp/pflistshidden.tmp"
		do shell script "cp /tmp/pflistshidden.tmp \"" & appdir & "default/SERVICES/hidden\""
		do shell script "rm -f /tmp/pflistshidden.tmp"
		-- update
		updateKnocking()
	end try
	set selected row of table view "serviceshidden" of scroll view "serviceshidden" of tab view item "knocking" of tab view "main" of window "main" to (selectedServiceRow - 1)
	doModifyPreset()
end delServiceHidden






-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					SERVICE DATABASE
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- SHOW LIST OF AVAILABLE SERVICES (FROM LOCAL FILE SERVICEDB)
on updateServiceDB()
	set theTableView to table view "servicedb" of scroll view "servicedb" of window "addservice"
	set the content of theTableView to {}
	set theDataSource to data source of theTableView
	-- count services 
	set serviceCount to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" | sed '/^$/d' |wc -l |bc"
	-- get lists list (used with parser in 'repeat')
	set serviceList to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" | sed '/^$/d'"
	try
		-- empty popups menu before building it
		-- FIREWALL POPUP
		try
			delete every menu item of menu of popup button "popup" of tab view item "firewall" of tab view "main" of window "main"
			make new menu item at end of menu of popup button "popup" of tab view item "firewall" of tab view "main" of window "main" with properties {title:"+", enabled:true}
		end try
		-- KNOCKING POPUP
		try
			delete every menu item of menu of popup button "popuphidden" of tab view item "knocking" of tab view "main" of window "main"
			make new menu item at end of menu of popup button "popuphidden" of tab view item "knocking" of tab view "main" of window "main" with properties {title:"+", enabled:true}
		end try
		--loop
		repeat with loopCounter from 1 to serviceCount
			set AppleScript's text item delimiters to {"#"}
			set theParagraph to paragraph loopCounter of serviceList
			--
			set theServiceID to text item 1 of theParagraph
			set theServiceSERVICE to text item 2 of theParagraph
			set theServicePROTOCOL to text item 3 of theParagraph
			set theServicePORTS to text item 4 of theParagraph
			--
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "id" of theTask to theServiceID
			set contents of data cell "service" of theTask to theServiceSERVICE
			set contents of data cell "protocol" of theTask to theServicePROTOCOL
			set contents of data cell "ports" of theTask to theServicePORTS
			--displayDialogOK("service:" & theServiceSERVICE)
			-- update popup
			make new menu item at end of menu of popup button "popup" of tab view item "firewall" of tab view "main" of window "main" with properties {title:theServiceSERVICE, enabled:true}
			try
				make new menu item at end of menu of popup button "popuphidden" of tab view item "knocking" of tab view "main" of window "main" with properties {title:theServiceSERVICE, enabled:true}
			end try
		end repeat
		set AppleScript's text item delimiters to {""}
	end try
end updateServiceDB




-- ADD NEW CUSTOM SERVICE
on addNewCustomService()
	display panel window "newcustomservice" attached to window "addservice"
end addNewCustomService


-- ADD THE NEW CUSTOM SERVICE TO SERVICE DATABASE
on addTheNewCustomService()
	close panel window "newcustomservice"
	-- get service name, protocol and ports
	try
		set theName to the contents of text field "name" of window "newcustomservice"
		set thePorts to the contents of text field "ports" of window "newcustomservice"
		set theProtocol to the title of popup button "protocol" of window "newcustomservice"
		-- get available ID 
		set serviceLastID to do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" | sed '/^$/d' |tail -1 |cut -d \"#\" -f1 |bc"
		set nextAvailableID to do shell script "seq -f \"%05g\" " & (serviceLastID + 1) & " |tail -1"
		-- build new line
		set newService to (nextAvailableID & "#" & theName & "#" & theProtocol & "#" & thePorts)
		-- purge shitty line
		set newService to do shell script "echo \"" & newService & "\" | sed '/^$/d' " as string
		-- add line to servicedb (old way)
		do shell script "echo \"" & newService & "\" >> \"" & appdir & "default/SERVICES/servicedb\""
	end try
	updateServiceDB()
	set the contents of text field "name" of window "newcustomservice" to ""
	set the contents of text field "ports" of window "newcustomservice" to ""
	doModifyPreset()
end addTheNewCustomService


-- DELETE SELECTED SERVICE FROM SERVICE DATABASE
on delCustomService()
	
	-- delete service from service database	
	try
		-- get selected service
		set tableView to table view "servicedb" of scroll view "servicedb" of window "addservice"
		set selectedRow to selected row of tableView
		set selectedID to the contents of data cell "id" of selected data row of tableView
	end try
	
	-- check service (do not delete service id 00001-all services)
	if selectedID is equal to "00001" then
		displayDialogOK("Sorry, you can't delete this service from services database.")
	else
		try
			-- delete service from database file
			do shell script "cat \"" & appdir & "default/SERVICES/servicedb\" | grep -v \"" & selectedID & "#\" | sed '/^$/d' > /tmp/pflists3.tmp"
			do shell script "cp /tmp/pflists3.tmp \"" & appdir & "default/SERVICES/servicedb\""
			do shell script "rm -f /tmp/pflists3.tmp"
			-- update
			
		end try
		
		-- delete service from all lists	
		try
			set theTableView to table view "lists" of scroll view "lists" of tab view item "firewall" of tab view "main" of window "main"
			set the content of theTableView to {}
			set theDataSource to data source of theTableView
			-- count lists (count directories in LISTS directory)
			set listsCount to do shell script "ls \"" & appdir & "default/LISTS/\"" & " |wc -l |bc"
			-- get lists list (used with parser in 'repeat')
			set listsList to do shell script "ls -l \"" & appdir & "default/LISTS/\"" & " |awk '{print $9}' |sed '/./,$!d'"
			
			-- loop
			repeat with loopCounter from 1 to listsCount
				try
					-- lists all directories (each dir is a PFLists list)
					set listName to paragraph loopCounter of listsList
					-- delete service from list's services
					do shell script "cat \"" & appdir & "default/LISTS/" & listName & "/services\" | grep -v \"" & selectedID & "#\" | sed '/^$/d' > /tmp/pflists4.tmp"
					do shell script "cp /tmp/pflists4.tmp \"" & appdir & "default/LISTS/" & listName & "/services\""
					do shell script "rm -f /tmp/pflists4.tmp"
				end try
			end repeat
			updateServiceDB()
			updateInterface()
			updateContent()
			updateServices()
		end try
	end if
	doModifyPreset()
end delCustomService

-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					PRESETS
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------

-- UPDATE PRESETS TABLE
on updatePresetsList()
	--displayDialogOK("updating presets table")
	try
		set theTableView to table view "presetstable" of scroll view "presets" of tab view item "presets" of tab view "main" of window "main"
		set the content of theTableView to {}
		set theDataSource to data source of theTableView
		-- count lists (count directories in LISTS directory)
		set listsCount to do shell script "ls \"" & appdir & "presets\"" & " | grep -v __MACOSX |wc -l |bc"
		set listsList to do shell script "ls \"" & appdir & "presets\" | grep -v __MACOSX"
		----------------------------------------------------------
		repeat with loopCounter from 1 to listsCount
			-- lists all directories (each dir is a PFLists preset)
			set listName to paragraph loopCounter of listsList
			--set theDescr to do shell script "cat \"" & appdir & "presets/" & listName & "/OPTIONS/description\""
			set theTask to make new data row at end of data rows of theDataSource
			set contents of data cell "presets" of theTask to listName
		end repeat
	on error errorTxt
		displayDialogOK("error updating presets table: " & errorTxt)
		
	end try
end updatePresetsList

-- WRITE NEW PRESET
on doCreatePreset()
	try
		set presetName to the contents of text field "addpreset" of window "addpreset"
		set presetExtendedName to presetName
		set presetDescr to the contents of text field "description" of window "addpreset"
		set presetDescr to (presetName & " # " & presetDescr)
		--purge name
		set presetName to do shell script "echo \"" & presetName & "\" | sed 's/ /_/g'"
		-- copy current configuration to new preset
		do shell script "cp -R \"" & appdir & "default\" \"" & appdir & "presets/" & presetName & "\""
		-- write a description to the new preset (overwriting previous one)
		do shell script "echo \"" & presetDescr & "\" > \"" & appdir & "presets/" & presetName & "/OPTIONS/description\""
		close panel window "addpreset"
		updatePresetsList()
		-- setting current config name as new preset
		
		do shell script "echo \"" & presetExtendedName & "#\" > \"" & appdir & "default/OPTIONS/description\""
		
		set the contents of text field "currentpreset" of tab view item "firewall" of tab view "main" of window "main" to "Current preset: " & presetExtendedName
	on error errorTxt
		displayDialogOK("Error creating preset: " & errorTxt)
	end try
end doCreatePreset


-- DELETE SELECTED PRESET
on deletePreset()
	set tableView to table view "presetstable" of scroll view "presets" of tab view item "presets" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set presetName to the contents of data cell "presets" of selected data row of tableView
	--
	set question to display dialog "Delete preset " & presetName & "?" buttons {"Yes", "No"} default button 1
	set answer to button returned of question
	if answer is equal to "Yes" then
		try
			do shell script "rm -rf \"" & appdir & "presets/" & presetName & "\""
		on error
			displayDialogOK("Error deleting preset " & presetName)
		end try
	end if
	updatePresetsList()
end deletePreset

-- PRESET CONFIRMATION PANEL
on showPresetConfirm()
	
	
	set tableView to table view "presetstable" of scroll view "presets" of tab view item "presets" of tab view "main" of window "main"
	set selectedRow to selected row of tableView
	set presetName to the contents of data cell "presets" of selected data row of tableView
	tell tab view "main" of window "main"
		set current tab view item to tab view item "firewall"
	end tell
	set the content of text field "presetname" of window "confirmpreset" to presetName
	set the visible of image view "picerr" of tab view item "firewall" of tab view "main" of window "main" to false as boolean
	set the visible of image view "picmid" of tab view item "firewall" of tab view "main" of window "main" to true as boolean
	tell progress indicator "spinner" of window "main" to start
	display panel window "confirmpreset" attached to window "main"
	
end showPresetConfirm



-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					LOGS
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
-- show
on showlogs()
	do shell script "open /var/log/pffirewall.log" with administrator privileges
end showlogs

-- export
on exportlogs()
	try
		tell save panel
			set prompt to "Export log file"
			set required file type to "txt"
		end tell
		display save panel
		set exportTo to path name of save panel
		-- do it
		try
			do shell script "cp /var/log/pffirewall.log \"" & exportTo & "\"" with administrator privileges
		on error errorTxt
			displayDialogOK("Error exporting file: " & errorTxt)
		end try
	end try
end exportlogs




-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--					CONFIGURATION
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
-- IMPORT
on importConf()
	tell tab view "main" of window "main"
		set current tab view item to tab view item "firewall"
	end tell
	
	try
		tell open panel
			set can choose directories to false
			set can choose files to true
			set allows multiple selection to false
			set prompt to "Import PFLists configuration"
			set required file type to "zip"
		end tell
		display open panel
	end try
	try
		set importFrom to path name of open panel
		-- unzip and copy
		try
			do shell script "cp -R /Library/Preferences/PFLists/default /Library/Preferences/PFLists/default_BACKUP"
		end try
		do shell script "rm -rf /Library/Preferences/PFLists/default"
		do shell script "unzip \"" & importFrom & "\" -d /Library/Preferences/PFLists/"
		-- copy advanced filt. conf file
		displayDialogOK("PFLists configuration imported. Click 'Apply' to enable the new ruleset.")
	on error errorTxt
		try
			do shell script "cp -R /Library/Preferences/PFLists/default_BACKUP /Library/Preferences/PFLists/default"
		end try
	end try
	updateInterface()
	updateContent()
	updateServices()
end importConf



-- EXPORT

on exportConf()
	try
		tell save panel
			set prompt to "OK"
			set required file type to "zip"
		end tell
		display save panel
		set exportTo to path name of save panel
		-- do it
		try
			do shell script "touch /Library/Preferences/PFLists/default/pflists"
			do shell script "cd /Library/Preferences/PFLists/ && zip -r default.zip default"
			do shell script "mv /Library/Preferences/PFLists/default.zip \"" & exportTo & "\""
			do shell script "\"" & binaryPath & "setfileicon\" \"" & binaryPath & "preset-icon.icns\" \"" & exportTo & "\""
		end try
	on error
		
	end try
end exportConf



-- GET INFO ABOUT CURRENT NETWORK CONFIGURATION

on networkSettings()
	try
		getPath()
		set mainInterface to ""
		set mainInterface to do shell script "route -n get 0.0.0.0 |grep interface |awk '/interface: / {print $2}'"
		
		if mainInterface contains "not in table" or mainInterface contains "routing socket" or mainInterface is equal to "" then
			displayDialogOK("Sorry, PFLists can't find a valid network interface. Please configure an interface with correct IP address, subnet mask and router address and retry.")
			quit
		end if
		
		set LocalIPaddress to do shell script "ifconfig " & mainInterface & " |grep \"inet \" |awk '{print $2}' |sed -n 1p"
		set LocalHEXMask to do shell script "ifconfig " & mainInterface & " |grep \"inet \" |awk '{print $4}' |sed -n 1p"
		set LocalMask to do shell script "sh \"" & binaryPath & "hex2dotdec\" " & LocalHEXMask
		set LocalNetworkAddress to do shell script "sh \"" & binaryPath & "mask\" " & LocalIPaddress & " " & LocalMask
		
		-- DISPLAY INFO IN HELP TAB
		set the contents of text field "bannernetwork" of tab view item "help" of tab view "main" of window "main" to ("Main network interface: " & mainInterface & "
IP address: " & LocalIPaddress & "  
Subnet mask: " & LocalMask & "  
Network address: " & LocalNetworkAddress)
	end try
end networkSettings



-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------
--				OPTION BUTTONS
-------------------------------------------------------------------------------------------------------------------------------
-------------------------------------------------------------------------------------------------------------------------------



-- EMERGING THREATS BUTTON

on setEmerging()
	if the content of button "emerging" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" is equal to true as boolean then
		do shell script "cat \"" & appdir & "default/OPTIONS/options\" | sed 's/emerging:0/emerging:1/' > /tmp/tmp_opt"
		do shell script "cp /tmp/tmp_opt \"" & appdir & "default/OPTIONS/options\""
		do shell script "rm -f /tmp/tmp_opt"
	else
		do shell script "cat \"" & appdir & "default/OPTIONS/options\" | sed 's/emerging:1/emerging:0/' > /tmp/tmp_opt"
		do shell script "cp /tmp/tmp_opt \"" & appdir & "default/OPTIONS/options\""
		do shell script "rm -f /tmp/tmp_opt"
	end if
	doModifyPreset()
end setEmerging

-- DUMMYNET BANDWIDTH
on setDummynet()
	if the content of button "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" is equal to true as boolean then
		set dummynetBW to the contents of text field "dummynet" of box "optionsbox" of tab view item "options" of tab view "main" of window "main"
		do shell script "echo \"" & dummynetBW & "\" > \"" & appdir & "default/OPTIONS/dummynet\""
	else
		do shell script "echo \"\" > \"" & appdir & "default/OPTIONS/dummynet\""
	end if
end setDummynet

-- COM.APPLE ANCHOR MANAGEMENT

on setComApple()
	if the content of button "comapple" of box "optionsbox" of tab view item "options" of tab view "main" of window "main" is equal to true as boolean then
		do shell script "cat \"" & appdir & "default/OPTIONS/options\" | sed 's/comapple:0/comapple:1/' > /tmp/tmp_opt"
		do shell script "cp /tmp/tmp_opt \"" & appdir & "default/OPTIONS/options\""
		do shell script "rm -f /tmp/tmp_opt"
	else
		do shell script "cat \"" & appdir & "default/OPTIONS/options\" | sed 's/comapple:1/comapple:0/' > /tmp/tmp_opt"
		do shell script "cp /tmp/tmp_opt \"" & appdir & "default/OPTIONS/options\""
		do shell script "rm -f /tmp/tmp_opt"
	end if
	doModifyPreset()
end setComApple

-- PORT KNOCKING

on setPortKnocking()
	if the content of button "knocking" of tab view item "knocking" of tab view "main" of window "main" is equal to true as boolean then
		do shell script "cat \"" & appdir & "default/OPTIONS/options\" | sed 's/knocking:0/knocking:1/' > /tmp/tmp_opt"
		do shell script "cp /tmp/tmp_opt \"" & appdir & "default/OPTIONS/options\""
		do shell script "rm -f /tmp/tmp_opt"
	else
		do shell script "cat \"" & appdir & "default/OPTIONS/options\" | sed 's/knocking:1/knocking:0/' > /tmp/tmp_opt"
		do shell script "cp /tmp/tmp_opt \"" & appdir & "default/OPTIONS/options\""
		do shell script "rm -f /tmp/tmp_opt"
	end if
	doModifyPreset()
end setPortKnocking

-- PORT KNOCKING PASSWORD

on setPortKnockingPWD()
	-- get values from fields
	try
		set passone to the contents of text field "pass1" of window "setpassword"
		set passtwo to the contents of text field "pass2" of window "setpassword"
		set passthree to the contents of text field "pass3" of window "setpassword"
		-- write to hiddenpwd file
		do shell script "echo \"" & passone & "\" > \"" & appdir & "default/SERVICES/hiddenpwd\""
		do shell script "echo \"" & passtwo & "\" >> \"" & appdir & "default/SERVICES/hiddenpwd\""
		do shell script "echo \"" & passthree & "\" >> \"" & appdir & "default/SERVICES/hiddenpwd\""
	end try
	--
	close panel window "setpassword"
	doModifyPreset()
end setPortKnockingPWD

-- MODIFY PRESET 

on doModifyPreset()
	try
		do shell script "echo \"custom#\" > \"" & appdir & "default/OPTIONS/description\""
	end try
	set the contents of text field "currentpreset" of tab view item "firewall" of tab view "main" of window "main" to "Current preset: custom"
end doModifyPreset

-- DEBUG WINDOW

on updatedebug()
	try
		set the contents of text view "runtime" of scroll view "runtime" of window "debug" to do shell script "pfctl -sr" with administrator privileges
		set the contents of text view "conf" of scroll view "conf" of window "debug" to do shell script "cat /Library/PFLists/pflists.conf" with administrator privileges
	end try
end updatedebug



-- IMPORT IP LIST 

on importList()
	-- parser
	-- " cat list  |grep -o '[0-9]\\{1,3\\}\\.[0-9]\\{1,3\\}\\.[0-9]\\{1,3\\}\\.[0-9]\\{1,3\\}' "
	try
		tell open panel
			set can choose directories to false
			set can choose files to true
			set allows multiple selection to false
			set prompt to "Import"
		end tell
		display open panel
	end try
	try
		set importFrom to path name of open panel
		set theParsedList to do shell script "cat \"" & importFrom & "\" |grep -o '[0-9]\\{1,3\\}\\.[0-9]\\{1,3\\}\\.[0-9]\\{1,3\\}\\.[0-9]\\{1,3\\}'  | tr \"\\n\" \" \" | tr \",\" \" \"   "
		set the contents of text field "addcontent" of window "addcontent" to theParsedList
	end try
	try
		checkOptions()
	end try
end importList

-- GET APPLICATION BUNDLE PATH 
on getPath()
	-- prendo path del bundle come stringa per poterla modificare
	set myPath to path to me as string
	-- aggiungo parte mancante al path dei binari eseguibili
	set macPath to (myPath & "Contents:Resources:")
	-- converto in formato POSIX il path dei binari esebuibili
	set binaryPath to POSIX path of macPath
end getPath

-- DISPLAY DRAWER
on showDrawer()
	getPath()
	set leading offset of drawer "maindrawer" of window "main" to "30"
	set trailing offset of drawer "maindrawer" of window "main" to "30"
	set contentSize to content size of drawer "maindrawer" of window "main"
	set item 1 of contentSize to 250
	set content size of drawer "maindrawer" of window "main" to contentSize
	set minimumSize to minimum content size of drawer "maindrawer" of window "main"
	set item 1 of minimumSize to 240
	set minimum content size of drawer "maindrawer" of window "main" to minimumSize
	set maxSize to maximum content size of drawer "maindrawer" of window "main"
	set item 1 of maxSize to 260
	set maximum content size of drawer "maindrawer" of window "main" to maxSize
	--
	tell drawer "maindrawer" of window "main" to open drawer on right edge
	
end showDrawer


-- CHECK OS X VERSION
on checkOSXversion()
	try
		set osVersion to do shell script "uname -r | cut -d \".\" -f1"
		if osVersion is equal to "8" then
			displayDialogOK("Sorry, Mac OS X 10.4 is not supported. Please use WaterRoof or NoobProof")
			quit
		else if osVersion is equal to "9" then
			displayDialogOK("Sorry, Mac OS X 10.5 is not supported. Please use WaterRoof or NoobProof")
			quit
		else if osVersion is equal to "10" then
			displayDialogOK("Sorry, Mac OS X 10.6 is not supported. Please use WaterRoof or NoobProof")
			quit
		else if osVersion is equal to "11" then
			set macosxVersion to "10.7"
			
		else if osVersion is equal to "12" then
			set macosxVersion to "10.8"
			
		else if osVersion is equal to "13" then
			set macosxVersion to "10.9"
			
		else if osVersion is equal to "14" then
			set macosxVersion to "10.10"
			
		else if osVersion is equal to "15" then
			set macosxVersion to "10.11"
			
			
		else if osVersion is equal to "16" then
			set macosxVersion to "10.12"
			
		end if
		-- check for Mac OS X Server
		set osVer to do shell script "sw_vers |grep ProductName: |cut -f2"
		if osVer is not equal to "Mac OS X" then
			displayDialogOK("OS X Server untested, use at your own risk.")
			-- quit
		end if
	end try
end checkOSXversion

----------- DIALOG HANDLERS
on displayDialogOK(theMsg)
	try
		set theDialog to display dialog (theMsg) buttons {"OK"} default button 1 with icon 1 -- attached to window (get first responder)
		set dialogReturn to "ok"
	on error
		set dialogReturn to "cancel"
	end try
end displayDialogOK
on displayDialog(theMsg)
	try
		set theDialog to display dialog (theMsg) buttons {"OK", "Cancel"} default button 1 with icon 1
		set dialogReturn to "ok"
	on error
		set dialogReturn to "cancel"
	end try
end displayDialog
-- EXAMPLE:
--set question to display dialog "Shouldn't you be doing something?" buttons {"Yes", "No"} default button 2
--set answer to button returned of question
--if answer is equal to "Yes" then
--	display dialog "Do it, then!" buttons {"No thanks", "Ok"} default button 2
--end if
--if answer is equal to "No" then
--	display dialog "Good for you." buttons {"I know", "Really?"} default button 2
--end if
-------------------------



































s